;Stazeno z www.HW.cz 
;				Autorem tohoto SW je Pavel.Gazda@seznam.cz
;--------------------------------------------------------------------------




EXTRN NUMBER(ADRGND,ADRUR,GND,REF,ADSEL,ADCONV,ADHB,ADDB)
EXTRN BIT(KONECAD)
EXTRN NUMBER(m,d,adrX,adrY,adrZ,adrP,sizeX,sizeY)
EXTRN CODE(deleni,nasXYdoX)


PUBLIC   anlkalibr,meranl,prepanl

ios segment code
rseg ios
;***************************************************************
;
; 	KALIBRACE ANALOGOVEHO PREVODNIKU
;
;***************************************************************
anlkalibr:

   MOV	  GND,#0
   MOV    GND+1,#0
   MOV    REF,#00FH
   MOV    REF+1,#0FFH
		
   MOV	  A,#ADRGND		; mereni minimalni hodnoty
   MOV    R0,#GND+1
   CALL   vstupanl

   MOV	  A,#ADRUR		; mereni maximalni hodnoty
   MOV    R0,#REF+1
   CALL   vstupanl


; vypocet hodnoty pro prepocet

   MOV    m+7,#0
   MOV    m+6,#0FFH
   MOV    m+5,#00FH
   MOV    adrX,#m+7             ; 4095*256

   MOV    m+3,REF+1
   MOV    m+2,REF
   MOV    m+1,#0
   MOV    adrY,#m+3             ; REF'

   MOV    SizeX,#3
   MOV    adrZ,#d+3
   MOV    adrP,#d+7

   CALL   deleni
                          ;   k :     m+6.m+7

   RET

;*********************************************************************
;
; Mereni ANALOGOVE veliciny:    AD prevodnik
;
;**********************************************************************

meranl:
	MOV	DPTR,#ADSEL	; prepni kanal
	MOVX	@DPTR,A

	MOV	DPTR,#ADCONV
	CLR     KONECAD
	MOVX	@DPTR,A		; prevod

mercek:
	JNB     KONECAD,mercek

	MOV	DPTR,#ADHB
	MOVX	A,@DPTR		; precteni hb
	MOV	B,A
	MOV	DPTR,#ADDB
	MOVX	A,@DPTR		; precteni db
	MOV	R1,A
	MOV	A,B
	ANL	B,#00Fh
	ANL	A,#0F0h
	ORL	A,R1

	CLR	C               ; odecti GND - pred ulozenim
	SUBB	A,GND+1
	XCH	A,B
	SUBB	A,GND
        XCH     A,B
	JNC	merref          ; min = 0

	MOV	@R0,#0
        DEC     R0
	MOV	@R0,#0
        INC     R0
	JMP	merret

merref:
        MOV     R1,A            ; max = REF - pred ulozenim
	SUBB	A,REF+1            ; C=0
        MOV     A,B
        SUBB    A,REF
        JC      merok

        MOV     @R0,REF+1
        DEC     R0
        MOV     @R0,REF
        INC     R0
        JMP     merret

merok:
        MOV     A,R1
        MOV     @R0,A
        DEC     R0
        MOV     @R0,B
        INC     R0

merret:
	RET		      ; merena hodnota v @R0-1,@R0

;***************************************************************
;
; 	PREPOCET VSTUPU Z ANALOGOVEHO PREVODNIKU
;
;***************************************************************

prepanl:
        MOV    adrY,#m+7      ; k
        MOV    SizeY,#2

        MOV    adrX,#m+3       ; X
        MOV    SizeX,#2

        CALL   NasXYdoX        ;  X :    m1,m2 . m3

        RET


end

;--------------------------------------------------------------------------
;Stazeno z www.HW.cz 
;				Autorem tohoto SW je Pavel.Gazda@seznam.cz

